%   CREATE AND INITIALIZE THE SYNTAX TABLES --------------

WANT_SYNTAX_HIGHLIGHT = 1;
create_syntax_table ("C");
define_syntax ("/*", "*/", '%', "C");
define_syntax ("//", "", '%', "C");
define_syntax ("([{", ")]}", '(', "C");
define_syntax ('"', '"', "C");
define_syntax ('\'', '\'', "C");
define_syntax ('\\', '\\', "C");
define_syntax ("0-9a-zA-Z_", 'w', "C");
define_syntax ("-+0-9a-fA-F.xXL", '0', "C");
define_syntax (",;.?:", ',', "C");
define_syntax ('#', '#', "C");
define_syntax ("%-+/&*=<>|!~^", '+', "C");
set_syntax_flags ("C", 0x4|0x40);
set_mode ("C", 2);


%   SET COLORS --------------------------------------------

$2="blue";

set_color("operator",   "white",            $2);
                                            % +, -, etc..

set_color("number",     "brightmagenta",    $2);
                                            % 10, 2.71,... TeX formulas

set_color("comment",    "brightcyan",       $2);
                                            % /* comment */

set_color("string",     "brightcyan",       $2);
                                            % "string" or 'char'

set_color("keyword",    "white",            $2);
                                            % if, while, unsigned, ...

set_color("keyword1",   "white",            $2);
                                            % malloc, exit, etc...

set_color("delimiter",  "brightblue",       $2);
                                            % {}[](),.;...

set_color("preprocess", "brightgreen",      $2);
                                            % #ifdef ....


%   TYPE 0 KEYWORDS ---------------------------------------

#iffalse
    () = define_keywords_n ("C", "doif", 2, 0);
#else
    () = define_keywords_n ("C", "doifor", 2, 0);
#endif
    () = define_keywords_n
    ("C", "andasmforintnewnottryxor", 3, 0);

    () = define_keywords_n
    ("C", "autoboolcasecharelseenumgotolongthistruevoid", 4, 0);

#iffalse
    () = define_keywords_n
    ("C", "breakcatchclassconstfalsefloatshortthrowunionusingwhile", 5, 0);

    () = define_keywords_n
    ("C", "deletedoubleexternfriendinlinepublic"
    +"returnsignedsizeofstaticstructswitchtypeid", 6, 0);
#else
    () = define_keywords_n
    ("C", "bitorbreakcatchclasscomplconst"
    +"falsefloator_eqshortthrowunionusingwhile", 5, 0);

    () = define_keywords_n
    ("C", "and_eqbitanddeletedoubleexportextern"
    +"friendinlinenot_eqpublicreturnsignedsizeof"
    +"staticstructswitchtypeidxor_eq", 6, 0);
#endif

    () = define_keywords_n
    ("C", "defaultmutableprivatetypedefvirtualwchar_t", 7, 0);

    () = define_keywords_n
    ("C", "continueexplicitoperatorregister"
    +"templatetypenameunsignedvolatile", 8, 0);

    () = define_keywords_n ("C", "namespaceprotected", 9, 0);
    () = define_keywords_n ("C", "const_cast", 10, 0);
    () = define_keywords_n ("C", "static_cast", 11, 0);
    () = define_keywords_n ("C", "dynamic_cast", 12, 0);
    () = define_keywords_n ("C", "reinterpret_cast", 16, 0);


%   TYPE 1 KEYWORDS (COMMON LIBC FUNCTIONS) ---------------

() = define_keywords_n("C","EOFabscosdivexplogpowsintan",3, 1);

() = define_keywords_n
    ("C","FILENULLacosasinatanatofatoiatolceilcosh"
    + "exitfabsfeoffmodfreegetcgetslabsldivmodf"
    + "putcputsrandsinhsqrttanhtime",
    4, 1);

() = define_keywords_n
    ("C","abortatan2clockctimediv_terrnofgetcfgets"
    + "floorfopenfputcfputsfreadfrexpfseekftell"
    + "ldexplog10qsortraisescanfsrandstdin",
    5, 1);

() = define_keywords_n
    ("C","assertatexitcallocfcloseferrorfflushfscanf"
    + "fwritegetenvgmtimemallocmemchrmemcmpmemcpy"
    + "memsetmktimeperrorprintfremoverenamerewind"
    + "setbufsetjmpsignalsize_tsscanfstderrstdout"
    + "strcatstrchrstrcmpstrcpystrlenstrspnstrstr"
    + "strtodstrtokstrtolsystemtime_ttmpnamungetc"
    + "va_argva_end",
    6, 1);

() = define_keywords_n
    ("C","asctimebsearchclock_tfgetposfprintffreopen"
    + "fsetposgetcharisalnumisalphaiscntrlisdigit"
    + "isgraphislowerisprintispunctisspaceisupper"
    + "jmp_buflongjmpmemmoveputcharreallocsetvbuf"
    + "sprintfstrcspnstrncatstrncmpstrncpystrpbrk"
    + "strrchrstrtoultmpfiletolowertoupperva_list"
    + "vprintf",
    7, 1);

() = define_keywords_n
    ("C","clearerrdifftimeisxdigitstrerror"
    + "strftimeva_startvfprintfvsprintf",
    8, 1);

() = define_keywords_n("C", "localtime", 9, 1);
