%----------------------------------------------------------
%   colors are and always will be unreliable
%   because they depend on the graphics adapter
%   because they depend on brand/model of display
%   because they depend on surrounding light
%   because they depend on user's perception
%   the only real option is: experiment!
%
%   use the console sequence ESC]Pnrrggbb to set colors
%   n   color number        0-f
%   rr  red component       00-ff   called blue in jed
%   gg  green component     00-ff
%   bb  blue component      00-ff   called red in jed
%
%   use the console sequence ESC]R to reset defaults
%
%   foreground      foreground
%   or              only
%   background
%
%   0 black         8 gray              gray, quite black
%   1 blue          9 brightblue
%   2 green         a brightgreen
%   3 cyan          b brightcyan
%   4 red           c brightred
%   5 magenta       d brightmagenta
%   6 brown         e yellow            brown, quite red
%   7 lightgray     f white
%
%   jed color names are in sldisply.c
%   jed color names are not same as in the console
%   jed color numbers are not same as the console color numbers!
%       3 <-> 6
%       1 <-> 4
%
%   to redefine
%       jed blue        use console color 4
%       jed cyan        use console color 6
%       jed red         use console color 1
%       jed brown       use console color 3
%
%   when sending escape sequences to console
%   remember that the console red component is jed blue component etc.
%
%----------------------------------------------------------

%   reset palette
tt_send ("\033]R");

tt_send ("\033]P55555ee");
%   this is a bright blue, numbered 5, called magenta!
%   the trick is required to use it as background color
%   linux accepts only colors 0-7 as background


%   FOREGROUND ON BACKGROUND  -----------------------------

$1 = "yellow";
$2 = "blue";
$3 = "white";

set_color ("normal",     $3, $2);           % default fg/bg
set_color ("operator",   $3, $2);           % +, -, etc..
set_color ("number",     $3, $2);           % 10, 2.71,... TeX formulas
set_color ("comment",    $3, $2);           % /* comment */
set_color ("string",     $3, $2);           % "string" or 'char'
set_color ("keyword",    $3, $2);           % if, while, unsigned, ...
set_color ("keyword1",   $3, $2);           % malloc, exit, etc...
set_color ("delimiter",  $1 ,$2);           % {}[](),.;...
set_color ("preprocess", $3, $2);           % #ifdef ....

set_color ("dollar",     "lightgray", $2);  % dollar sign continuation
%set_color ("...",       "brown",     $2);  % folding indicator
set_color ("...",        "lightgray", "brown");
set_color ("message",    "yellow",    $2);  % messages
set_color ("region",     $3, "magenta");    % block highlight
                                            % magenta is a cheat

set_color ("error",      "lightgray", "red");   % errors
set_color ("status",     "black", "lightgray"); % status line

set_color ("menu",                "black",      "lightgray");
set_color ("menu_char",           "red",        "lightgray");
set_color ("menu_popup",          "black",      "lightgray");
set_color ("menu_selection",      $3,           "cyan");
set_color ("menu_selection_char", $3,           "cyan");

%   sue has no menu shadow

%%  in jed text mode, cursor has same color as normal text
%%  under X11 it can have a distinct color
%%  sue does color the cursor distinctly

%   tt_send ("\033]PaaB4FFB4");
%   $5 = "#B4FFB4"; % pale green

set_color ("cursor",    $3, $2);
set_color ("cursorovr", $2, "lightgray");
